Subject: [stir] RFC 8224: signed-identity-digest syntax

From: "Cooney, Chris" <[email-masked]>
Date: Fri, 12 Jun 2020 20:18:50 +0000

Howdy,

I'm involved with a point of interop confusion relating to RFC's 8224 and 8225.  The ultimate question is if "-" and "_" are allowed in the signed-identity-digest part of a SIP Identity header.

Section 4 of RFC 8224 specifies "/" and "+" (which are part of the base64 alphabet from RFC 4648), and NOT "-" and "_" (part of the base64url alphabet from RFC 4648).

   ........................................................The revised
   grammar for the Identity header field builds on the ABNF [RFC5234] in
   [RFC3261], Section 25.  It is as follows:

      Identity = "Identity" HCOLON signed-identity-digest SEMI
          ident-info *( SEMI ident-info-params )
      signed-identity-digest = 1*(base64-char / ".")
      ident-info = "info" EQUAL ident-info-uri
      ident-info-uri = LAQUOT absoluteURI RAQUOT
      ident-info-params = ident-info-alg / ident-type /
          ident-info-extension
      ident-info-alg = "alg" EQUAL token
      ident-type = "ppt" EQUAL token
      ident-info-extension = generic-param

      base64-char = ALPHA / DIGIT / "/" / "+"

   The signed-identity-digest contains a base64 encoding of a PASSporT
   [RFC8225]...

The RFC 8224 reference below says base64 is being used in RFC 8225, but that RFC uses base64url.
section 4.1:
   After these two JSON objects, the header and the payload, have been
   constructed and base64-encoded, they must each be hashed and signed
   per [RFC8225], Section 6.  The header, payload, and signature
   components comprise a full PASSporT object.

And despite the section 4 grammar for Identity header, sections 4.1.1 and 5.1 of RFC 8224 show examples of Identity headers with "-".

RFC 8225 consistently specifies base64url with matching examples containing "-" or "_" in the encoded Passports.

Please help to clarify!

Thank you,
Chris Cooney
3605 E Plano Pkwy | Plano, TX 75074 USA
office: +1.972.805.9214  | mobile: +1.972.824.3639
[GENBAND.com]
<https://ribboncommunications.com/>

-----------------------------------------------------------------------------------------------------------------------
Notice: This e-mail together with any attachments may contain information of Ribbon Communications Inc. that
is confidential and/or proprietary for the sole use of the intended recipient.  Any review, disclosure, reliance or
distribution by others or forwarding without express permission is strictly prohibited.  If you are not the intended
recipient, please notify the sender immediately and then delete all copies, including any attachments.
-----------------------------------------------------------------------------------------------------------------------